/// As the first permutation of the matrix. Covered in 'general length input with unique permutations' (*1)
/// state: initial input = {4, 4, 3, 2, 1, 0}, final output = {3, 3, 1, 2, 0}, final index = 0

/// as the last permutation of the matrix. 'Covered in transform with reversely-sorted initial order_array' (*3) 
/// state: initial input = {4, 4, 3, 2, 1, 0}, final output = {4, 2, 3, 4, 1, 0}, final index = 3

/// between the first and last permutations of the matrix. Covered in 'general length input with repeated permutations' (*2)
/// state: initial input = {6, 3, 1, 2, 3, 1, 2, 0}, final output = {6, 3, 3, 1, 1, 2, 2}, final index = 4 


/// input-case where lexicographic sorting eventually stops the comparison at the first character. Covered in 'general length input with unique permutations' (*1)
/// state: initial input = {3, 1, 2, 3, 0}, final output = {3, 3, 1, 2, 0}, final index = 0

/// input-case where lexicographic sorting eventually stops the comparison at the last character. Covered in 'general length input with repeated permutations' (*2)'
/// state: initial input = {3, 1, 2, 3, 1, 2}, final output = {6, 3, 3, 1, 1, 2, 2}, final index = 4

/// input-case where lexicographic sorting eventually stops the comparison between the first and last character
procedure main()
    int input[] = {1, 2, 1}
    int index = 0
    int output[size(input)]

    call rev_bwt(input, output, index)
    //uncall rev_bwt(input, output, index)
